<?php
/*
Plugin Name: GV Excel Export
Plugin URI: wpgear.xyz/gv-excel-export
Description: Make Export to normal Excel file from GravityView Forms. Check out the features of the PRO version: <a href="http://wpgear.xyz/gv-excel-export-pro/">"GV Excel-Export PRO"</a>.
Version: 2.4.2
Author: WPGear
Author URI: http://wpgear.xyz
License: GPLv2
*/

	$GVXL_plugin_url = plugin_dir_url( __FILE__);	// со слэшем на конце
	$GVXL_plugin_dir = plugin_dir_path( __FILE__);	// со слэшем на конце		
	
	include_once(__DIR__ .'/includes/admin.php');

	/* Стили для Админки GV
	----------------------------------------------------------------- */	
	function GVXL_admin_style () {
        if (function_exists ('gravityview_is_admin_page')) {
            if (gravityview_is_admin_page()) {
				global $GVXL_plugin_url;
				
				$Style_Path = $GVXL_plugin_url .'admin-style.css';
				wp_enqueue_style ('gvxl_admin', $Style_Path);
				
				$Style_Path = "https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css";
				wp_enqueue_style ('fontawesome_4.7.0', $Style_Path);					
            }
        }	
	}
	add_action ('admin_enqueue_scripts', 'GVXL_admin_style');

	/* Registering Styles with GravityView when running on "no-conflict mode"
	----------------------------------------------------------------- */
	function GVXL_register_safe_styles( $styles ){
		$styles[] = "gvxl_admin";
		$styles[] = "fontawesome_4.7.0";
		
		return $styles;
	}
	add_filter('gravityview_noconflict_styles', 'GVXL_register_safe_styles' );	
	
	/* Стили для Фронтенд
	----------------------------------------------------------------- */	
	function GVXL_stylesheets(){
		global $GVXL_plugin_url;
		
		$Style_Path = $GVXL_plugin_url .'style.css';
		wp_enqueue_style('gvxl', $Style_Path, false, null );
		
		// Font Awesome
		wp_enqueue_style('fontawesome_4.7.0', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');	
	}
	add_action ('wp_enqueue_scripts','GVXL_stylesheets');	
	
	/* Excel Export Settings - GV Settings
	----------------------------------------------------------------- */	
	function GVXL_GV_Settings_Fields ($Fields) {
		$GV_Settings = get_option('gravityformsaddon_gravityview_app_settings', array());
		
		$GV_Settings_ExcelExport = isset($GV_Settings['excel-export']) ? sanitize_text_field($GV_Settings['excel-export']) : '1';
		
		$Fields[] = array (
			'name' => 'excel-export',
			'type' => 'radio',
			'label' => 'Excel Export',
			'default_value' => $GV_Settings_ExcelExport,
			'horizontal' => 1,
			'choices' => 
			array (
			  0 => 
			  array (
				'label' => 'Enable',
				'value' => '1',
			  ),
			  1 => 
			  array (
				'label' => 'Disable',
				'value' => '0',
			  ),
			),
			'description' => 'Make Export to normal Excel file from Gravityview Forms.',
			'tooltip' => '<p>Each GV Form has a separate switch On/Off.</p>',
		  );			
		
		return $Fields;
	}
	add_filter ('gravityview_settings_fields', 'GVXL_GV_Settings_Fields');
	
	/* Excel Export Settings - Default.
	----------------------------------------------------------------- */		
	function GVXL_GV_Settings_Default ($Settings) {
		$Settings['excel-export'] = 1;	
		
		return $Settings;
	}
	add_filter('gravityview/settings/defaults', 'GVXL_GV_Settings_Default');	
	
	/* ShortCode: Excel Export Button.
	----------------------------------------------------------------- */	
	function GVXL_Shortcode_Button( $atts, $shortcode_content = null){	
		$GV_Settings = get_option('gravityformsaddon_gravityview_app_settings', array());
		$GV_Settings_ExcelExport 	= isset($GV_Settings['excel-export']) ? intval($GV_Settings['excel-export']) : true;
		
		if ($GV_Settings_ExcelExport) {
			$Site_URL = get_site_url();
			
			// Try get G-View ID		
			global $wp_query;
			$GV = get_query_var('gravityview');
			$GV_ID = null;
			
			if ($GV) {
				$GV_View = (array) $GV->view;
				$GV_Post = array_values($GV_View)[0];
				$GV_ID = $GV_Post->ID;
			}				
			
			if ($GV_ID) {
				$key = 'gvxl_excel-export_control';
				$ExcelExport_Control = get_post_meta( $GV_ID, $key, true );				
				
				if ($ExcelExport_Control) {	
					$Requests = array();
					
					$Request_Search 	= isset($_REQUEST['gv_search']) ? sanitize_text_field ($_REQUEST['gv_search']) : null;
					$Request_Sorting 	= isset($_REQUEST['sort']) ? sanitize_text_field ($_REQUEST['sort']) : null;		
					
					if ($Request_Search) {
						$Requests['gv_search'] = $Request_Search;
						$Requests['mode'] = 'any';
					}	
					
					$Redirect_URL = $_SERVER['REDIRECT_URL'];		
					$Excel_URL = $Site_URL .$Redirect_URL .'?out=excel';					
					
					if ($GV_ID) {
						$Excel_URL = $Excel_URL .'&gv_id=' .$GV_ID;
					}
					
					foreach ($Requests as $key => $value) {
						$Excel_URL = $Excel_URL .'&' .$key .'=' .$value;
					}
					
					if (is_array($Request_Sorting)) {
						$Sort_Field 	= array_keys($Request_Sorting)[0];
						$Sort_Direction = array_values($Request_Sorting)[0];
						
						$Excel_URL = $Excel_URL .'&sort%5B' .$Sort_Field .'%5D=' .$Sort_Direction;
					}						
					
					// PRO Version	
					// datepicker					
					
					ob_start();
					?>
					<div>
						<div>
							<i class="fa fa-2x fa-file-excel-o" onclick="GVXL_excel_fields_box_Togle_Show ()" title="Export to Excel" style="color: green; cursor: pointer;" aria-hidden="true"></i>
						</div>
						<div id="gvxl_excel_fields_box" class="gvxl_excel_fields_box" style="display: none;">
							<div class="gvxl_excel_fields_box_fields">
								<div class="gvxl_excel_fields_box_fields_item">
									<label for="gvxl_excel_field_date_from">Date from: </label>
									<input id="gvxl_excel_field_date_from" name="gvxl_excel_field_date_from" onchange="GVXL_excel_change_fields_date_note()" type="text" class="datepicker">
								</div>
								<div class="gvxl_excel_fields_box_fields_item">
									<label for="gvxl_excel_field_date_to">Date to: </label>
									<input id="gvxl_excel_field_date_to" name="gvxl_excel_field_date_to" onchange="GVXL_excel_change_fields_date_note()" type="text" class="datepicker">
								</div>	
							</div>
							
							<div>
								<span id="gvxl_excel_fields_date_note" class="gvxl_excel_fields_date_note"></span>
							</div>
							
							<div class="gvxl_excelexport_button">
								<input id="gvxl_excel_btn_submit" onclick="GVXL_excel_submit ()" type="button" class="button" value="Start Export">
							</div>
						</div>
					</div>
					<script>
						var GVXL_excel_fields_box_Show = false;
						var DateSeparator = '.';
						
						var Now = new Date();
						var Today_Y = Now.getFullYear();
						var Today_M = ("0" + (Now.getMonth() + 1)).slice(-2);			
						var Today_D = ("0" + Now.getDate()).slice(-2);
						document.getElementById ('gvxl_excel_field_date_to').value = Today_D + DateSeparator + Today_M + DateSeparator + Today_Y;
							
						if (Today_D > 10) {
							// Start from Current Month
							var FirstDayPrevMonth_Y = Today_Y;
							var FirstDayPrevMonth_M = Today_M;				
							var FirstDayPrevMonth_D = '01';
							
							document.getElementById ('gvxl_excel_fields_date_note').innerHTML = '* Date range: first Day current Month -> Today.';
						} else {
							// Start from Prev. Month
							var FirstDayPrevMonth = new Date(Now.getFullYear(), Now.getMonth() - 1, 1);
							var FirstDayPrevMonth_Y = FirstDayPrevMonth.getFullYear();
							var FirstDayPrevMonth_M = ("0" + (FirstDayPrevMonth.getMonth() + 1)).slice(-2);				
							var FirstDayPrevMonth_D = ("0" + FirstDayPrevMonth.getDate()).slice(-2);
							
							document.getElementById ('gvxl_excel_fields_date_note').innerHTML = '* Date range: first Day prev. Month -> Today.';
						}	

						document.getElementById ('gvxl_excel_field_date_from').value = FirstDayPrevMonth_D + DateSeparator + FirstDayPrevMonth_M + DateSeparator + FirstDayPrevMonth_Y;
						
						function GVXL_excel_fields_box_Togle_Show () {
							// Show/Hide fields box.
							GVXL_excel_fields_box_Show = !GVXL_excel_fields_box_Show;				
							
							if (GVXL_excel_fields_box_Show) {
								document.getElementById ('gvxl_excel_fields_box').style.display = 'inline-block';
							} else {
								document.getElementById ('gvxl_excel_fields_box').style.display = 'none';
							}
						}
						
						function GVXL_excel_submit () {
							var GVXL_Excel_Date_from = document.getElementById ('gvxl_excel_field_date_from').value;
							var GVXL_Excel_Date_to 	= document.getElementById ('gvxl_excel_field_date_to').value;				
							var Location = "<?php echo $Excel_URL;?>";
							
							if (GVXL_Excel_Date_from) {
								Location = Location + "&date_from=" + GVXL_Excel_Date_from;
							}
											
							if (GVXL_Excel_Date_to) {
								Location = Location + "&date_to=" + GVXL_Excel_Date_to;
							}				

							window.location.href = Location;
						}
						
						function GVXL_excel_change_fields_date_note () {
							document.getElementById ('gvxl_excel_fields_date_note').innerHTML = '* Date range: Custom.';
						}
					</script>
					<?php		
					$content = ob_get_clean();
					
					return $content;
				}				
			}
		}
	}
	add_shortcode( 'gvxl_button_excelexport', 'GVXL_Shortcode_Button' );	
	
	// Advanced requests. 
	function GVXL_template_redirect() {
		$Request_Output = isset($_REQUEST['out']) ? sanitize_text_field ($_REQUEST['out']) : null;
		
		global $wp_query;
		
		$Post = $wp_query->post;		
		
		if ($Request_Output == 'excel') {
			// Create Excel File.
			GVXL_ExcelExport_Processing($Post);
		}		
	}
	add_action( 'template_redirect', 'GVXL_template_redirect' );	

	// Create Excel File.
	function GVXL_ExcelExport_Processing($Post) {
		if (! class_exists('GFForms')) {
			die();
		} else {
			if (! class_exists('PHPExcel')) {	
				global $GVXL_plugin_dir;
				include_once($GVXL_plugin_dir .'/lib/phpExcel_7.4/PHPExcel.php');
			}
		
			$Post_ID 	= $Post->ID;			
			$Post_Type 	= $Post->post_type;	
			$Post_Title = $Post->post_title;

			$Request_Search 	= isset($_REQUEST['gv_search']) ? sanitize_text_field ($_REQUEST['gv_search']) : null;
			$Request_Sorting 	= isset($_REQUEST['sort']) ? sanitize_text_field ($_REQUEST['sort']) : null;
			$Date_Start 		= isset($_REQUEST['date_from']) ? sanitize_text_field ($_REQUEST['date_from']) : null;
			$Date_End 			= isset($_REQUEST['date_to']) ? sanitize_text_field ($_REQUEST['date_to']) : null;				
		
			$GV_Form_ID = null;			
			if ($Post_Type == 'page' || $Post_Type == 'post') {
				// Page with Shortcode.
				$GV_Form_ID = isset($_REQUEST['gv_id']) ? sanitize_text_field ($_REQUEST['gv_id']) : null;				
				
				if ($GV_Form_ID) {
					$GV_Form_ID = intval($GV_Form_ID);
				}
			} else if ($Post_Type == 'gravityview') {
				// Page G-View
				$GV_Form_ID = $Post_ID;				
			} else {
				// Somthing Wrong.
				echo 'Somthing Wrong. GVXL_ExcelExport_Processing';
				die();
			}

			if ($GV_Form_ID) {			
				$key = '_gravityview_form_id';
				$Form_ID = get_post_meta($GV_Form_ID, $key, true);
	
				$Form = GFAPI::get_form($Form_ID);
				
				$Current_User 	= wp_get_current_user();
				$User_ID 		= $Current_User->ID;
				$User_Name 		= $Current_User->user_login;				
				
				$UserRoles 	= GVXL_Get_UserRoles($User_ID);		
		
				$key = '_gravityview_template_settings';
				$GV_Settings = get_post_meta($GV_Form_ID, $key, true);

				$key = '_gravityview_filters';
				$GV_Filters = get_post_meta($GV_Form_ID, $key, true);

				$key = '_gravityview_directory_fields';
				$GV_Table_Columns = get_post_meta($GV_Form_ID, $key, true);
				$GV_Table_Columns = $GV_Table_Columns['directory_table-columns'];

				if ($GV_Settings) {
					$Show_Only_Approved = $GV_Settings['show_only_approved'];
				}
				
				$Search_Criteria = array ();

				if ($GV_Filters) {
					$GW_Version				= $GV_Filters['version'];
					$GV_Filters_Conditions 	= $GV_Filters['conditions'];
					
					$Search_Criteria['version'] = $GW_Version;
				}
				
				$Search_Criteria['status'] = 'active';	
				$Search_Criteria['field_filters']['mode'] = 'all';
				
				if ($Show_Only_Approved) {
					$Search_Criteria['field_filters'][] = array( 'key' => 'is_approved', 'value' => true );
				}
					
				if ($Date_Start) {					
					$Date_Start = date('Y-m-d', strtotime ($Date_Start));
					$Search_Criteria['start_date'] = $Date_Start;
				} else {
					$Date_Start = $GV_Settings['start_date'];
					
					if ($Date_Start) {
						// Date from GV Filters.
						$Search_Criteria['start_date'] = $Date_Start;
					} else {
						// Set Default.
						$Search_Criteria['start_date'] = '2000-01-01';
					}
				}
				
				if ($Date_End) {
					$Date_End = date('Y-m-d', strtotime ($Date_End));
					$Search_Criteria['end_date'] = $Date_End;
				} else {
					$Date_End = $GV_Settings['end_date'];
					
					if ($Date_End) {
						// Date from GV Filters.
						$Search_Criteria['end_date'] = $Date_End;
					} else {
						// Set Default.
						$Search_Criteria['end_date'] = current_time('Y-m-d');
					}
				}		

				// GV Filters					
				$Temp_Search_Criteria 	= array();
				$Trigger_OnCreatedBy 	= false;
				$Trigger_OnLoggedIn 	= false;
				$GW_Advanced_Filter		= false;
				
				$Description = '';
							
				if (function_exists('gv_extension_advanced_filtering_load')) {
					// GravityView - Advanced Filter Extension
					$GW_Advanced_Filter = true;
				
					if ($GV_Filters_Conditions) {
						foreach ($GV_Filters_Conditions as $Condition) {
							foreach ($Condition['conditions'] as $Item) {
								$Item_Key 		= $Item['key'];
								$Item_Operator 	= $Item['operator'];
								$Item_value 	= $Item['value'];
								
								if ($Item_Key == 'created_by') {
									$Trigger_OnCreatedBy = true;
									
									if ($Item_value == 'created_by') {
										if ($GW_Advanced_Filter) {
											$Trigger_OnLoggedIn = true;
										}
									} 
								} else {
									$Temp_Search_Criteria[] = array(
										'key' => $Item_Key, 
										'operator' => $Item_Operator, 
										'value' => $Item_value
									);								
								}							
							}
						}
					}

					// GVXL Фильтры Привелегий. Admin. PRO Version.
					$key = 'gvxl_filter_admin_control';
					$Filter_Admin_Control = get_post_meta( $GV_Form_ID, $key, true );				
					
					if ($Filter_Admin_Control) {
						// Check User for Administrator.
						if (in_array('administrator', $UserRoles)) {
							// Administrator. Get all Records.
							$Description = 'Look like: Administrator';
						}
					} 
					
					// Inspector. Special PRO Version.
					// ...
					
					if ($Description == '') {
						// Easy User. Apply GW Filters.
						if ($Trigger_OnLoggedIn) {
							// Main Criteria.
							$Search_Criteria['field_filters'][] = array(
								'key' => 'created_by', 
								'operator' => 'is', 
								'value' => $User_ID
							);

							$Description = 'Look like: Member';							
						} else {
							$Description = 'Look like: As is';
						}
					}					
				}
				
				// All Filters. (lite version ...)
				foreach ($Temp_Search_Criteria as $key => $value) {
					if (in_array('created_by', $value)) {
						// Clear all Criteria as "created_by".
						unset($Temp_Search_Criteria[$key]);
					} else {
						// Add GV Filter.
						// $Search_Criteria['field_filters'][] = $value;
					}
				}

				if ($Request_Search) {
					// Get Records with Search Requests.
					$Search_Criteria['field_filters'][] = array( 'value' => $Request_Search );
				}
				
				// Filter from GV Widget. PRO Version.

				$Sorting = array();
                
                if (is_array($Request_Sorting)) {
					// Sorting.
					$Sort_Field 	= array_keys($Request_Sorting)[0];
					$Sort_Direction = array_values($Request_Sorting)[0];
					
					$Sorting = array( 'key' => $Sort_Field, 'direction' => $Sort_Direction); 
					// ,'is_numeric' => true ); - need type of Fields.
				}				
				
				$Count_Entries = GFAPI::count_entries( $Form_ID, $Search_Criteria );
				$Paging = array( 'offset' => 0, 'page_size' => $Count_Entries );

				$Entries = GFAPI::get_entries($Form_ID, $Search_Criteria, $Sorting, $Paging);			

				// Normalize File Name.
				$DateTime = current_time('Ymd_Hi');
				
				$File_Subject = $Post_Title;
				$rule = 'Any-Latin; Latin-ASCII; Lower;';

				$File_Subject = Transliterator::create($rule)->transliterate($File_Subject); 
				$File_Subject = html_entity_decode ($File_Subject);
				$File_Subject = sanitize_file_name ($File_Subject);			
				
				$File_Title = $User_Name .' ' .$DateTime;
				$File_Title = Transliterator::create($rule)->transliterate($File_Title); 
				$File_Title = html_entity_decode ($File_Title);
				$File_Title = sanitize_file_name ($File_Title);			
				
				$File_Name = $File_Subject .'-' .$File_Title .'.xls';				
								
				$Headers 			= wp_list_pluck( $GV_Table_Columns, 'label' );			
				$Fields_ID 			= wp_list_pluck( $GV_Table_Columns, 'id' );
				$Custom_Headers 	= wp_list_pluck( $GV_Table_Columns, 'custom_label' );
				$Custom_Content 	= wp_list_pluck( $GV_Table_Columns, 'content' );			
				$Date_Format 		= wp_list_pluck( $GV_Table_Columns, 'date_display' );
				
				// Hide Columns. PRO Version.
				
				// Any types of GV Fields - any Headers.
				foreach ($Custom_Headers as $key => $value) {
					if ($value != '') {						
						$Headers[$key] = $value;
					}
				}

				// Alternative Headers for Excel. PRO Version.

				$Headers = array_values($Headers);			
			
				$Data_Sheet = array();
				$Data_Sheet[] = $Headers;	

				foreach ( $Entries as $Entry ) {
					$Data_Row = array();			
					
					foreach ( $Fields_ID as $key => &$value ) {
						$Data_Cell = $Entry[$value];
						
						if ($value == 'custom') {
							// Not Easy Fields: Formula, Shortcode...
							if ( class_exists( 'GFCommon' ) ) {	
								$Data_Cell = $Custom_Content[$key];	
								$Data_Cell = GFCommon::replace_variables( $Data_Cell, $Form, $Entry, false, true, true, 'html', array () );
							}
						}				
						
						if ($Date_Format[$key]) {
							// Field type "Date". Need convert to Excel.
							$Data_Cell = date("Y.m.d", strtotime($Data_Cell));
							$Data_Cell = PHPExcel_Shared_Date::PHPToExcel($Data_Cell);
						}
						
						$Data_Row[] = $Data_Cell;					
					}
					
					$Data_Sheet[] = $Data_Row;
				}

				// Note About DateRange;
				$Note_About_DateRange = '';
				if ($Date_Start) {
					$Note_About_DateRange .= $Date_Start .' - ';
				} else {
					$Note_About_DateRange .= 'frome begin - ';
				}

				if ($Date_End) {
					$Note_About_DateRange .= $Date_End;
				} else {
					$Note_About_DateRange .= current_time('Y-m-d');
				}				
				
				$xls = new PHPExcel();		

				$xls->getProperties()->setTitle("GVXL Reports. $File_Title");
				$xls->getProperties()->setSubject($File_Subject);
				$xls->getProperties()->setCreator($User_Name);
				$xls->getProperties()->setCompany("My Company");
				$xls->getProperties()->setCategory("Back-Office");			
				$xls->getProperties()->setDescription("Top Secret. $Description");				
				
				$xls->setActiveSheetIndex(0);
				$sheet = $xls->getActiveSheet();
				$sheet->setTitle($Note_About_DateRange);		

				$sheet->getColumnDimension("A")->setWidth(1.0);
				
				// "A1". Any others start Cells may Conflicted of data Indexes.
				$Start_Column 	= 'A';
				$Start_Row 		= 1;
				$Start_Cell 	= $Start_Column .$Start_Row;
								
				$sheet->fromArray($Data_Sheet, null, $Start_Cell);
				
				$Last_Column 	= $sheet->getHighestDataColumn();
				$Last_Row 		= $sheet->getHighestDataRow();

				$ColumnIterator = $sheet->getColumnIterator();

				// Cell Styles.
				$Borders_Thin = array(
					'borders'=>array(
						'outline' => array(
							'style' => PHPExcel_Style_Border::BORDER_THIN,
							'color' => array('rgb' => '000000')
						),
					)
				);

				// Post Processing.
				$i = 0;
				foreach( $ColumnIterator as $Column ) {
					$Column_Index = $Column->getColumnIndex();
					
					// AutoSize Column 
					$sheet->getColumnDimension( $Column_Index )->setAutoSize(true);
					
					// Formating Headers.
					$Cell = $Column_Index .$Start_Row;					
					
					$sheet->getStyle($Cell)->getFont()->setBold(true);
					$sheet->getStyle($Cell)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
					$sheet->getStyle($Cell)->applyFromArray($Borders_Thin);

					// Formating Column type: "Date"
					$Date_Format_Column 		= array_slice($Date_Format, $i, 1);					
					$Date_Format_Column_Value 	= array_values ($Date_Format_Column)[0];
					$Date_Format_Column_Key 	= array_keys ($Date_Format_Column)[0];

					if ($Date_Format_Column_Value) {
						// Formate: Date Excel - not formates: Date PHP. (Y, M, F, n, j - and others, not correct.)
						
						// const FORMAT_DATE_YYYYMMDD2 = 'yyyy-mm-dd';
						// const FORMAT_DATE_YYYYMMDD = 'yy-mm-dd';
						// const FORMAT_DATE_DDMMYYYY = 'dd/mm/yy';
						// const FORMAT_DATE_DMYSLASH = 'd/m/y';
						// const FORMAT_DATE_DMYMINUS = 'd-m-y';
						
						$Date_Format_Column_Value = str_replace("y", "yy", $Date_Format_Column_Value);
						$Date_Format_Column_Value = str_replace("Y", "yyyy", $Date_Format_Column_Value);
						$Date_Format_Column_Value = str_replace("F", "mm", $Date_Format_Column_Value);						
						$Date_Format_Column_Value = str_replace("M", "mm", $Date_Format_Column_Value);
						$Date_Format_Column_Value = str_replace("m", "mm", $Date_Format_Column_Value);
						$Date_Format_Column_Value = str_replace("mmmm", "mm", $Date_Format_Column_Value);
						$Date_Format_Column_Value = str_replace("n", "m", $Date_Format_Column_Value);												
						$Date_Format_Column_Value = str_replace("d", "dd", $Date_Format_Column_Value);
						$Date_Format_Column_Value = str_replace("j", "d", $Date_Format_Column_Value);
						
						$sheet->getStyle($Column_Index .($Start_Row + 1) .':' .$Column_Index .$Last_Row)->getNumberFormat()->setFormatCode($Date_Format_Column_Value);
					}

					$i = $i + 1;	
				}
				
				ob_end_clean();
				
				header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
				header('Content-Disposition: attachment;filename=' .$File_Name);
				header('Cache-Control: max-age=0');

				$writer = PHPExcel_IOFactory::createWriter($xls, 'Excel5');				
			
				$writer->save('php://output');
			}
		}
	}

	// User Roles
	function GVXL_Get_UserRoles ($user_id) {
		$user_meta = get_userdata($user_id);
		$user_roles = $user_meta->roles;		
		
		return $user_roles;
	}